<?php
/**
 * Clothing Marketplace functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package clothing_marketplace
 */

if ( ! defined( 'CLOTHING_MARKETPLACE_VERSION' ) ) {
	define( 'CLOTHING_MARKETPLACE_VERSION', '1.0' );
}

$clothing_marketplace_theme_data = wp_get_theme();

if( ! defined( 'CLOTHING_MARKETPLACE_THEME_VERSION' ) ) define ( 'CLOTHING_MARKETPLACE_THEME_VERSION', $clothing_marketplace_theme_data->get( 'Version' ) );
if( ! defined( 'CLOTHING_MARKETPLACE_THEME_NAME' ) ) define( 'CLOTHING_MARKETPLACE_THEME_NAME', $clothing_marketplace_theme_data->get( 'Name' ) );

if ( ! function_exists( 'clothing_marketplace_setup' ) ) :
	
	function clothing_marketplace_setup() {
		
		load_theme_textdomain( 'clothing-marketplace', get_template_directory() . '/languages' );

		add_theme_support( 'woocommerce' );

		add_theme_support( 'automatic-feed-links' );
		
		add_theme_support( 'title-tag' );

		add_theme_support( 'post-thumbnails' );

		register_nav_menus(
			array(
				'primary' => esc_html__( 'Primary', 'clothing-marketplace' ),
			)
		);

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'style',
				'script',
				'woocommerce',
			)
		);

		add_theme_support( 'post-formats', array(
			'image',
			'video',
			'gallery',
			'audio', 
		) );

		add_theme_support(
			'custom-background',
			apply_filters(
				'clothing_marketplace_custom_background_args',
				array(
					'default-color' => 'ffffff',
					'default-image' => '',
				)
			)
		);

		add_theme_support( 'customize-selective-refresh-widgets' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 250,
				'width'       => 250,
				'flex-width'  => true,
				'flex-height' => true,
			)
		);

		add_theme_support( 'align-wide' );

		add_theme_support( 'responsive-embeds' );

		/*  Demo Import */
		require get_parent_theme_file_path( '/theme-wizard/config.php' );

		/*
		* This theme styles the visual editor to resemble the theme style,
		* specifically font, colors, icons, and column width.
		*/
		add_editor_style( '/resource/css/editor-style.css' );

	}
endif;
add_action( 'after_setup_theme', 'clothing_marketplace_setup' );

function clothing_marketplace_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'clothing_marketplace_content_width', 640 );
}
add_action( 'after_setup_theme', 'clothing_marketplace_content_width', 0 );

function clothing_marketplace_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'clothing-marketplace' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'clothing-marketplace' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title"><span>',
			'after_title'   => '</span></h2>',
		)
	);

	// Regsiter 4 footer widgets.
	$clothing_marketplace_footer_widget_column = get_theme_mod('clothing_marketplace_footer_widget_column','4');
	for ($clothing_marketplace_i=1; $clothing_marketplace_i<=$clothing_marketplace_footer_widget_column; $clothing_marketplace_i++) {
		register_sidebar( array(
			'name' => __( 'Footer  ', 'clothing-marketplace' )  . $clothing_marketplace_i,
			'id' => 'footer-widget-' . $clothing_marketplace_i,
			'description' => __( 'The Footer Widget Area', 'clothing-marketplace' )  . $clothing_marketplace_i,
			'before_widget' => '<aside id="%1$s" class="widget %2$s">',
			'after_widget' => '</aside>',
			'before_title' => '<div class="widget-header"><h4 class="widget-title">',
			'after_title' => '</h4></div>',
		) );
	}
}
add_action( 'widgets_init', 'clothing_marketplace_widgets_init' );

/**
 * Enqueue scripts and styles.
 */
function clothing_marketplace_scripts() {
	// Append .min if SCRIPT_DEBUG is false.
	$min = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';

	// Fontawesome style.
	wp_enqueue_style( 'font-awesome-css', esc_url(get_template_directory_uri())."/resource/css/fontawesome-all.css" );

	// Main style.
	wp_enqueue_style( 'clothing-marketplace-style', get_template_directory_uri() . '/style.css', array(), CLOTHING_MARKETPLACE_VERSION );

	// RTL style.
	wp_style_add_data('clothing-marketplace-style', 'rtl', 'replace');

	if (get_theme_mod('clothing_marketplace_enable_animation', true) == true){
		// Animate CSS
		wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/resource/css/animate.css' );
		// Wow script.
		wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/resource/js/wow.js', array('jquery'),'' ,true );
	}

	wp_enqueue_style( 'owl.carousel-css', esc_url(get_template_directory_uri())."/resource/css/owl.carousel.css" );

	// Navigation script.
	wp_enqueue_script( 'clothing-marketplace-navigation-script', get_template_directory_uri() . '/resource/js/navigation.js', array(), CLOTHING_MARKETPLACE_VERSION, true );

	wp_enqueue_script( 'owl.carousel-js', esc_url(get_template_directory_uri()) . '/resource/js/owl.carousel.js', array( 'jquery' ), CLOTHING_MARKETPLACE_VERSION, true );

	// Custom script.
	wp_enqueue_script( 'clothing-marketplace-custom-script', get_template_directory_uri() . '/resource/js/custom.js', array( 'jquery', 'owl.carousel-js' ), CLOTHING_MARKETPLACE_VERSION, true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	// Include the file.
	require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );

	// Load the webfont.
	wp_enqueue_style(
		'Raleway',
		Clothing_Marketplace_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Raleway:ital,wght@0,100..900;1,100..900&display=swap' ),
		array(),
		'1.0'
	);

	// Load the webfont.
	wp_enqueue_style(
		'Cabin',
		Clothing_Marketplace_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Cabin:ital,wght@0,400..700;1,400..700&display=swap' ),
		array(),
		'1.0'
	);
}
add_action( 'wp_enqueue_scripts', 'clothing_marketplace_scripts' );

//Change number of products per page 
add_filter( 'loop_shop_per_page', 'clothing_marketplace_products_per_page' );
function clothing_marketplace_products_per_page( $cols ) {
  	return  get_theme_mod( 'clothing_marketplace_products_per_page',9);
}

// Change number or products per row 
add_filter('loop_shop_columns', 'clothing_marketplace_loop_columns');
	if (!function_exists('clothing_marketplace_loop_columns')) {
	function clothing_marketplace_loop_columns() {
		return get_theme_mod( 'clothing_marketplace_products_per_row', 3 );
	}
}

/**
 * Include wptt webfont loader.
 */
require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/theme-library/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/theme-library/function-files/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/theme-library/function-files/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/theme-library/customizer.php';

/**
 * Google Fonts
 */
require get_template_directory() . '/theme-library/function-files/google-fonts.php';

/**
 * Dynamic CSS
 */
require get_template_directory() . '/theme-library/dynamic-css.php';

/**
 * Breadcrumb
 */
require get_template_directory() . '/theme-library/function-files/class-breadcrumb-trail.php';

/**
 * Customizer Settings Functions
*/
require get_template_directory() . '/theme-library/function-files/customizer-settings-functions.php';

/**
 * Getting Started
*/
require get_template_directory() . '/theme-library/getting-started/getting-started.php';

function clothing_marketplace_links_setup() {
	if ( ! defined( 'CLOTHING_MARKETPLACE_PREMIUM_PAGE' ) ) {
	define('CLOTHING_MARKETPLACE_PREMIUM_PAGE',__('https://asterthemes.com/products/clothing-store-wordpress-theme','clothing-marketplace'));
	}
	if ( ! defined( 'CLOTHING_MARKETPLACE_THEME_PAGE' ) ) {
		define('CLOTHING_MARKETPLACE_THEME_PAGE',__('https://asterthemes.com/products/clothing-marketplace','clothing-marketplace'));
	}
	if ( ! defined( 'CLOTHING_MARKETPLACE_SUPPORT' ) ) {
	define('CLOTHING_MARKETPLACE_SUPPORT',__('https://wordpress.org/support/theme/clothing-marketplace/','clothing-marketplace'));
	}
	if ( ! defined( 'CLOTHING_MARKETPLACE_REVIEW' ) ) {
	define('CLOTHING_MARKETPLACE_REVIEW',__('https://wordpress.org/support/theme/clothing-marketplace/reviews/','clothing-marketplace'));
	}
	if ( ! defined( 'CLOTHING_MARKETPLACE_PRO_DEMO' ) ) {
	define('CLOTHING_MARKETPLACE_PRO_DEMO',__('https://demo.asterthemes.com/clothing-marketplace/','clothing-marketplace'));
	}
	if ( ! defined( 'CLOTHING_MARKETPLACE_THEME_DOCUMENTATION' ) ) {
	define('CLOTHING_MARKETPLACE_THEME_DOCUMENTATION',__('https://demo.asterthemes.com/docs/clothing-marketplace-free/','clothing-marketplace'));
	}
	if ( ! defined( 'CLOTHING_MARKETPLACE_PREMIUM_DOCUMENTATION' ) ) {
	define('CLOTHING_MARKETPLACE_PREMIUM_DOCUMENTATION',__('https://demo.asterthemes.com/docs/clothing-marketplace-pro/','clothing-marketplace'));
	}
	if ( ! defined( 'CLOTHING_MARKETPLACE_BUNDLE_PAGE' ) ) {
		define('CLOTHING_MARKETPLACE_BUNDLE_PAGE',__('https://asterthemes.com/products/wp-theme-bundle','clothing-marketplace'));
	}
}
add_action('after_setup_theme', 'clothing_marketplace_links_setup');

// Enqueue Customizer live preview script
function clothing_marketplace_customizer_live_preview() {
    wp_enqueue_script(
        'clothing-marketplace-customizer',
        get_template_directory_uri() . '/resource/js/customizer.js',
        array('jquery', 'customize-preview'),
        '',
        true
    );
}
add_action('customize_preview_init', 'clothing_marketplace_customizer_live_preview');

// Featured Image Dimension
function clothing_marketplace_blog_post_featured_image_dimension(){
	if(get_theme_mod('clothing_marketplace_blog_post_featured_image_dimension') == 'custom' ) {
		return true;
	}
	return false;
}
add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );

function clothing_marketplace_get_product_categories() {
	$categories = get_terms( array(
		'taxonomy'   => 'product_cat',
		'hide_empty' => false,
	) );

	$options = array( '' => __( 'All Categories', 'clothing-marketplace' ) );

	if ( ! empty( $categories ) && ! is_wp_error( $categories ) ) {
		foreach ( $categories as $category ) {
			$options[ $category->slug ] = $category->name;
		}
	}

	return $options;
}

// Reset all theme settings
function clothing_marketplace_reset_demo_import_settings() {
    if (current_user_can('manage_options')) {
        // List only demo import-related settings to reset
		remove_theme_mod('clothing_marketplace_enable_topbar');
		remove_theme_mod('clothing_marketplace_location_view_button_text');
		remove_theme_mod('clothing_marketplace_location_view_button_url');
		remove_theme_mod('clothing_marketplace_order_view_button_text');
		remove_theme_mod('clothing_marketplace_order_view_button_url');
		remove_theme_mod('clothing_marketplace_enable_header_search_section');
		remove_theme_mod('clothing_marketplace_enable_banner_section');
		remove_theme_mod('clothing_marketplace_banner_section_heading');
		remove_theme_mod('clothing_marketplace_banner_section_sub_heading');
		remove_theme_mod('clothing_marketplace_banner_section_content');
		remove_theme_mod('clothing_marketplace_banner_button_label_one');
		remove_theme_mod('clothing_marketplace_banner_button_link_one');
		remove_theme_mod('clothing_marketplace_banner_button_label_two');
		remove_theme_mod('clothing_marketplace_banner_button_link_two');
		remove_theme_mod('clothing_marketplace_banner_right_title');
		remove_theme_mod('clothing_marketplace_banner_image_title');
		remove_theme_mod('clothing_marketplace_enable_product_section');
		remove_theme_mod('clothing_marketplace_trending_product_heading');
		remove_theme_mod('clothing_marketplace_product_view_button_text');
		remove_theme_mod('clothing_marketplace_product_view_button_url');

        wp_send_json_success(array('message' => __('Demo import settings have been reset.', 'clothing-marketplace')));
    } else {
        wp_send_json_error(array('message' => __('Permission denied.', 'clothing-marketplace')));
    }
}
add_action('wp_ajax_clothing_marketplace_reset_demo_import_settings', 'clothing_marketplace_reset_demo_import_settings'); 